import std.stdio;

void main()
{
    int[4] fixed = [1, 2, 3, 4];
    auto anotherFixed = fixed;
    assert(anotherFixed !is fixed); // Не то же са­мое (ко­пи­ро­ва­ние по зна­че­нию)
    assert(anotherFixed == fixed);  // Те же дан­ные
    auto dynamic = fixed[];         // По­лу­ча­ет гра­ни­цы мас­си­ва fixed
    assert(dynamic is fixed);
    assert(dynamic == fixed);       // Ес­те­ст­вен­но
    dynamic = dynamic.dup;          // Соз­да­ет ко­пию
    assert(dynamic !is fixed);
    assert(dynamic == fixed);
}
